/**
 * ScandiPWA - Progressive Web App for Magento
 *
 * Copyright © Scandiweb, Inc. All rights reserved.
 * See LICENSE for license details.
 *
 * @license OSL-3.0 (Open Software License ("OSL") v. 3.0)
 * @package scandipwa/base-theme
 * @link https://github.com/scandipwa/base-theme
 */

$select-width: 160px !default;
$select-height: 45px !default;
$select-option-height: 36px !default;
$select-arrow-height: 6px !default;
$select-arrow-width: 6px !default;

:root {
    --select-option-background: #fff;
    --select-option-hover-background: #f0f0f0;
}

.Field {
    margin-top: 1rem;

    > input {
        padding: 13px 36px 13px 20px;
    }

    label {
        padding-bottom: 0.3rem;
        font-size: 12px;
        font-weight: 700;
    }

    &-Message {
        margin-bottom: -0.1em !important;
        font-size: 10px;

        @include after-mobile {
            margin-top: 1px;
            margin-left: 20px;
        }
    }

    &-Note {
        height: 0;
        margin-bottom: 0.2rem;
        opacity: 0;
        color: var(--field-note);
        font-size: 1rem;
        font-weight: 600;
        transition: height 0.1s ease-in, opacity 0.1s linear;
        will-change: height, opacity;

        &::before {
            content: '* ';
        }
    }

    &-Select {
        width: 100%;
        min-width: 100%;
        padding-right: 40px;

        @include after-mobile {
            pointer-events: none;
        }

        &_isExpanded {
            border-color: var(--input-color);
        }

        &Wrapper {
            cursor: pointer;

            &::after {
                display: block;
                width: $select-arrow-width;
                height: $select-arrow-height;
                border-width: 0 1px 1px 0;
                border-color: #000;

                border-style: solid;
                margin: auto;

                position: absolute;
                top: 0;
                right: 20px;
                bottom: 0;
                transform: translateY(-2px) rotate(45deg);
                pointer-events: none;
                content: '';
            }

            &_isExpanded::after {
                @include after-mobile {
                    bottom: $select-arrow-height * 3/2;
                    transform: translateY(-2px) rotate(-135deg);
                }
            }
        }

        &Options {
            width: 100%;
            max-height: 0;
            border-width: 0 1px 1px;
            border-color: transparent;
            border-style: solid;
            position: absolute;
            top: 100%;
            left: 0;
            z-index: 40;
            transition: 200ms max-height;

            overflow-y: scroll;
            will-change: max-height;
            -webkit-overflow-scrolling: touch;

            &_isExpanded {
                @include after-mobile {
                    max-height: 200px;
                    border-color: var(--input-border-color);
                }
            }
        }

        &Option {
            max-height: $select-option-height;
            padding: 0;
            padding-left: 1.5rem;
            margin: 0;
            z-index: 1;
            background: var(--select-option-background);
            line-height: 3rem;
            transition: 100ms max-height ease-in;
            will-change: max-height;

            &::before {
                content: none;
            }

            &:last-of-type {
                margin: 0;
            }

            &:hover,
            &:focus {
                @include after-mobile {
                    background: var(--select-option-hover-background);
                }
            }
        }
    }

    &_hasError {
        input,
        textarea {
            border: 1px solid var(--primary-error-color) !important;
        }
    }

    &::placeholder {
        color: var(--field-note);
        font-size: 0.9rem;
    }

    input:focus + .Field-Note {
        height: 100%;
        opacity: 1;
    }

    &_type {
        &_checkbox,
        &_radio {
            display: flex;
            align-items: baseline;

            label {
                margin: 0;
                font-weight: 400;
                cursor: pointer;

                &:first-of-type {
                    display: inline-block;
                    max-width: calc(100vw - 2rem - 45px);
                    padding-bottom: 0;
                    padding-left: 1rem;
                    order: 1;
                    text-align: left;

                    ~ label {
                        margin: 0;
                        top: 0.3rem;
                    }
                }

                &:last-of-type {
                    display: inline-block;
                }
            }
        }

        &_checkbox {
            flex-direction: revert;

            &.Field_hasError {
                padding-bottom: 23px;
                color: var(--red-color);

                a {
                    color: var(--red-color);
                }
            }

            .Field-Message {
                position: absolute;
                top: 24px;
                left: 8px;
            }
        }

        &_text,
        &_password {
            input {
                &::placeholder,
                &::-webkit-input-placeholder {
                    opacity: 0;
                    transition: opacity 0.2s ease;
                }
            }

            input + label {
                min-width: unset;
                padding-right: 2px;
                padding-left: 2px;
                position: absolute;
                top: 14px;
                left: 18px;
                z-index: 10;
                color: var(--grey-4-color);
                font-size: 14px;
                font-weight: normal;
                transition: all 0.15s ease-in-out;
            }

            input:focus,
            input.isDirty {
                &::placeholder {
                    opacity: 1;
                }

                + label {
                    top: -6px;
                    left: 15px;
                    color: var(--primary-base-color);
                    background: white;
                    font-size: 10px;
                }
            }

            &.Field_hasError {
                .Field-ClearButton {
                    width: 22px;
                    height: 24px;
                    position: absolute;
                    top: 9px;
                    right: 13px;
                    z-index: 10;
                    background-image: url('../../style/images/input_wrong.svg');
                    cursor: pointer;
                }
            }
        }
    }

    [type='checkbox'],
    [type='radio'] {
        min-width: 0;
        min-height: 0;
        padding: 0;
        position: absolute;
        opacity: 0;

        + label {
            --box-color: #{white};

            display: inline-block;
            width: 16px;
            height: 16px;
            padding: 0;
            border: 1px solid var(--primary-base-color);
            border-radius: 1px;
            position: relative;
            flex-shrink: 0;
            background-color: var(--box-color);
            transition-property: background-color, border-color;
            transition-duration: 0.25s;
            transition-timing-function: ease-in;
            cursor: pointer;
            will-change: background-color, border-color;

            &::after {
                position: absolute;
                bottom: 0;
                left: 2px;
                pointer-events: none;
                content: '';
            }
        }

        &:disabled + label {
            color: #b8b8b8;
            cursor: auto;
        }
    }

    [type='checkbox'] {
        &:checked + label {
            &::after {
                content: url('../../style/images/checkmark.svg');
            }
        }
    }

    [type='radio'] {
        + label {
            border-radius: 50%;

            &::after {
                width: 0.5rem;
                height: 0.5rem;
                border-radius: 50%;
                margin: auto;
                top: 0;
                right: 0;
                bottom: 0;
                left: 0;
                transition-property: background-color, box-shadow;
                will-change: background-color, box-shadow;
            }
        }

        &:focus + label {
            --box-color: var(--secondary-light-color);

            border-color: var(--primary-base-color);

            &::after {
                --checkmark-color: #{$white};
            }
        }

        &:checked + label {
            &::after {
                width: 12px;
                height: 12px;
                background: var(--primary-base-color);
            }
        }
    }
}
